package comunicacao;

import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.net.InetAddress;

public interface ISocket {

	void sendObject(Serializable ojb) throws IOException;
	
	void sendFile(File file) throws IOException;
	
	void sendFile(File file, Object fileState) throws IOException;
	
	Serializable readObject() throws IOException, ClassNotFoundException;
	
	File readFile() throws IOException, ClassNotFoundException;
	
	boolean connect() throws IOException;
	
	void close() throws IOException;
	
	InetAddress getRemoteAddress();
	
	int getRemotePort();
		
	
	
}
