/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Principal.java
 *
 * Created on Jun 7, 2012, 8:15:34 AM
 */
package gui;

import java.io.File;
import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.UnknownHostException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Hashtable;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.filechooser.FileSystemView;
import javax.swing.table.DefaultTableModel;

import data.User;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;

import core.InformationServerUser;
import core.ServerComunication;

/**
 *
 * @author dfop
 */
public class Principal extends javax.swing.JFrame {

	private String[] totalUsers;
	private ArrayList<InformationServerUser> loggedUsers;
	private DefaultTableModel model;
	private ServerComunication serverComunication;
	
    /** Creates new form Principal */
    public Principal() {
        initComponents();
        
        this.model = (DefaultTableModel) tabela.getModel();
        this.totalUsers = null;
        this.loggedUsers = null;
        this.mudarIcone();
       
        try {
			this.serverComunication = new ServerComunication();
			this.serverComunication.start();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
        
        //this.metodoExemplo();
        //this.preencherTabela();
      
    }

    
    public void metodoExemplo() {

		tabela.getColumn("").setCellRenderer(new MyCellRenderer());
		model.setRowCount(0);   
		
		User aux = null;
		Icon icon = null; 	
		String ipName = "";

		//Caso esteja logado colocar green_led

		aux = new User("Dyego", "dfop", "dfop123");
		icon = new ImageIcon("src/gui/green_led.gif");
		InetAddress ip = null;
		try {
			ip = InetAddress.getByName("192.168.254.1");
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		aux.setCurrentIP(ip);
		ipName = aux.getCurrentIP().toString();
		ipName = ipName.substring(1);
		
		Object[] rowData = new Object[] {icon, aux.getName(), ipName, "Synchronized"};   
		model.addRow(rowData); 
		
		
		aux = new User("Pedro", "phtg", "phtg123");
		InetAddress ip2 = null;
		try {
			ip2 = InetAddress.getByName("192.168.254.7");
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		aux.setCurrentIP(ip2);
		icon = new ImageIcon("src/gui/red_led.gif");
		ipName = aux.getCurrentIP().toString();
		ipName = ipName.substring(1);

		Object[] rowData2 = new Object[] {icon, aux.getName(), ipName, "Synchronized"};   
		model.addRow(rowData2);   

    }
    
    public void mudarIcone(){
        
        BufferedImage image = null;
        
        try {    
            image = ImageIO.read(this.getClass().getResource("/gui/AppIcon.png"));
        } catch (IOException ex) {
            
        }
        
        this.setIconImage(image);
        this.setTitle("Server");
    }
    
    public void preencherTabela() {
        tabela.getColumn("").setCellRenderer(new MyCellRenderer());
        model.setRowCount(0);   

        Icon icon = null; 	
        //boolean achou = false;
        String ip = "";
        String status = "";

        this.loggedUsers = this.serverComunication.getInformationServerUsers();
        
//        hashUserDatabase = null;// retornar database
//        hashLoggedUsers =null;// retornar usuarios logados
//
//        totalUsers = new ArrayList<User>(hashUserDatabase.values());
//        loggedUsers = new ArrayList<User>(hashLoggedUsers.values());
        
      
        
        for(InformationServerUser aux : this.loggedUsers){
        	icon = new ImageIcon("src/gui/green_led.gif");
        	status = "Synchronized";
        	
        	Object[] rowData = new Object[] {icon, aux.getUser().getEmail(), aux.getIP(), status};   
            model.addRow(rowData); 
            System.out.println(aux.getUser().getEmail());
        }
        
        

//        for (User aux : this.totalUsers) {   
//
//            //Checando se esse usuario esta logado
//            for(int i = 0; i < loggedUsers.size() && !achou; i++) {
//
//                    if(aux.getCurrentIP().equals(loggedUsers.get(i).getCurrentIP()) ) {
//                            achou = true;
//                    }
//            }
//
//            //Caso esteja logado colocar green_led
//            if(achou) {
//                    icon = new ImageIcon("/gui/green_led.gif");
//                    achou = false;
//            } else {
//                    icon = new ImageIcon("/gui/red_led.gif");
//            }
//
//            //Tirando a '\' na frente do endereco ip
//            ip = aux.getCurrentIP().toString();
//            ip = ip.substring(1);
//
//            status = "Synchronized";// Preciso de um metodo que retorne o status
//
//            Object[] rowData = new Object[] {icon, aux.getName(), ip, status};   
//            model.addRow(rowData);   
//        }   	
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        tabela = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        botaoUsers = new javax.swing.JButton();
        botaoFiles = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(640, 480));
        setResizable(false);
        getContentPane().setLayout(null);

        tabela.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "", "User", "IP", "Status"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(tabela);
        tabela.getColumnModel().getColumn(0).setMinWidth(20);
        tabela.getColumnModel().getColumn(0).setPreferredWidth(20);
        tabela.getColumnModel().getColumn(0).setMaxWidth(20);

        getContentPane().add(jScrollPane1);
        jScrollPane1.setBounds(170, 11, 600, 450);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 36));
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("YamBox");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(10, 50, 190, 44);

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/Logo YamServer.png"))); // NOI18N
        getContentPane().add(jLabel3);
        jLabel3.setBounds(10, 290, 150, 160);

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 36));
        jLabel4.setForeground(new java.awt.Color(255, 255, 255));
        jLabel4.setText("Server");
        getContentPane().add(jLabel4);
        jLabel4.setBounds(30, 110, 130, 30);

        botaoUsers.setText("See users");
        botaoUsers.setOpaque(false);
        botaoUsers.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoUsersMouseClicked(evt);
            }
        });
        getContentPane().add(botaoUsers);
        botaoUsers.setBounds(20, 180, 130, 23);

        botaoFiles.setText("See files");
        botaoFiles.setOpaque(false);
        botaoFiles.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoFilesMouseClicked(evt);
            }
        });
        getContentPane().add(botaoFiles);
        botaoFiles.setBounds(20, 220, 130, 23);

        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/background.jpg"))); // NOI18N
        getContentPane().add(jLabel2);
        jLabel2.setBounds(0, 0, 790, 480);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-795)/2, (screenSize.height-507)/2, 795, 507);
    }// </editor-fold>//GEN-END:initComponents

private void botaoUsersMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_botaoUsersMouseClicked
    // preencher tabela com os usuarios logados
    this.preencherTabela();
}//GEN-LAST:event_botaoUsersMouseClicked

private void botaoFilesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_botaoFilesMouseClicked
    // preencher tablea com os arquivos
}//GEN-LAST:event_botaoFilesMouseClicked

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
    	
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
            	
            	try {
					UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
				} catch (ClassNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedLookAndFeelException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
            	
                new Principal().setVisible(true);
                
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botaoFiles;
    private javax.swing.JButton botaoUsers;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tabela;
    // End of variables declaration//GEN-END:variables
}
